/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MailchimpControllerActionListRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MailchimpControllerActionListRequest{}

// MailchimpControllerActionListRequest struct for MailchimpControllerActionListRequest
type MailchimpControllerActionListRequest struct {
	OAuthId *string `json:"oAuthId,omitempty"`
	Dc      *string `json:"dc,omitempty"`
}

// NewMailchimpControllerActionListRequest instantiates a new MailchimpControllerActionListRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMailchimpControllerActionListRequest() *MailchimpControllerActionListRequest {
	this := MailchimpControllerActionListRequest{}
	return &this
}

// NewMailchimpControllerActionListRequestWithDefaults instantiates a new MailchimpControllerActionListRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMailchimpControllerActionListRequestWithDefaults() *MailchimpControllerActionListRequest {
	this := MailchimpControllerActionListRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *MailchimpControllerActionListRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MailchimpControllerActionListRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *MailchimpControllerActionListRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *MailchimpControllerActionListRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetDc returns the Dc field value if set, zero value otherwise.
func (o *MailchimpControllerActionListRequest) GetDc() string {
	if o == nil || IsNil(o.Dc) {
		var ret string
		return ret
	}
	return *o.Dc
}

// GetDcOk returns a tuple with the Dc field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MailchimpControllerActionListRequest) GetDcOk() (*string, bool) {
	if o == nil || IsNil(o.Dc) {
		return nil, false
	}
	return o.Dc, true
}

// HasDc returns a boolean if a field has been set.
func (o *MailchimpControllerActionListRequest) HasDc() bool {
	if o != nil && !IsNil(o.Dc) {
		return true
	}

	return false
}

// SetDc gets a reference to the given string and assigns it to the Dc field.
func (o *MailchimpControllerActionListRequest) SetDc(v string) {
	o.Dc = &v
}

func (o MailchimpControllerActionListRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MailchimpControllerActionListRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Dc) {
		toSerialize["dc"] = o.Dc
	}
	return toSerialize, nil
}

type NullableMailchimpControllerActionListRequest struct {
	value *MailchimpControllerActionListRequest
	isSet bool
}

func (v NullableMailchimpControllerActionListRequest) Get() *MailchimpControllerActionListRequest {
	return v.value
}

func (v *NullableMailchimpControllerActionListRequest) Set(val *MailchimpControllerActionListRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableMailchimpControllerActionListRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableMailchimpControllerActionListRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMailchimpControllerActionListRequest(val *MailchimpControllerActionListRequest) *NullableMailchimpControllerActionListRequest {
	return &NullableMailchimpControllerActionListRequest{value: val, isSet: true}
}

func (v NullableMailchimpControllerActionListRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMailchimpControllerActionListRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
